﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenGL4NET;

namespace Semestralka
{
    class Ground
    {
        int size;
        float[][] pole;
        float[][] normaly;

        float texX;
        float texXplus;
        float texZ;
        float texZplus;

        public Ground(float[][] pole)
        {
            this.pole = pole;
            size = pole.Length;
            normaly = new float[size * size][];
            spoctiNormaly();
        }

        private void spoctiNormaly()
        {
            Vector3 p0;
            Vector3 p1;
            Vector3 p2;
            Vector3 p3;
            Vector3 p4;

            Vector3 v1;
            Vector3 v2;
            Vector3 v3;
            Vector3 v4;

            Vector3 n;

            for (int z = 0; z < size; z++)
            {
                for (int x = 0; x < size; x++)
                {
                    p0 = new Vector3(x, pole[z][x], z);

                    if (z != 0 && x != 0 && z != size - 1 && x != size - 1)
                    {
                        // vnitrek site krome kraju

                        p1 = new Vector3(x, pole[z + 1][x], z + 1);
                        p2 = new Vector3(x + 1, pole[z][x + 1], z);
                        p3 = new Vector3(x, pole[z - 1][x], z - 1);
                        p4 = new Vector3(x - 1, pole[z][x - 1], z);

                        v1 = p1 - p0;
                        v2 = p2 - p0;
                        v3 = p3 - p0;
                        v4 = p4 - p0;

                        n = Vector3.Cross(ref v1, ref v2) + Vector3.Cross(ref v2, ref v3) + Vector3.Cross(ref v3, ref v4) + Vector3.Cross(ref v4, ref v1);
                        n.Normalize();

                        normaly[z * size + x] = new float[3] { n.x, n.y, n.z };
                    }
                    else
                    {
                        if (x > 0 && x < size - 1)
                        {
                            if (z == 0)
                            {
                                p1 = new Vector3(x, pole[z + 1][x], z + 1);
                                p2 = new Vector3(x + 1, pole[z][x + 1], z);
                                p4 = new Vector3(x - 1, pole[z][x - 1], z);

                                v1 = p1 - p0;
                                v2 = p2 - p0;
                                v4 = p4 - p0;

                                n = Vector3.Cross(ref v1, ref v2) + Vector3.Cross(ref v2, ref v4) + Vector3.Cross(ref v4, ref v1);
                                n.Normalize();

                                normaly[z * size + x] = new float[3] { n.x, n.y, n.z };
                            }
                            if (z == size -1)
                            {
                                p2 = new Vector3(x + 1, pole[z][x + 1], z);
                                p3 = new Vector3(x, pole[z - 1][x], z - 1);
                                p4 = new Vector3(x - 1, pole[z][x - 1], z);

                                v2 = p2 - p0;
                                v3 = p3 - p0;
                                v4 = p4 - p0;

                                n = Vector3.Cross(ref v2, ref v3) + Vector3.Cross(ref v3, ref v4) + Vector3.Cross(ref v4, ref v2);
                                n.Normalize();

                                normaly[z * size + x] = new float[3] { n.x, n.y, n.z };
                            }
                        }
                        else if (z > 0 && z < size - 1)
                        {
                            if (x == 0)
                            {
                                p1 = new Vector3(x, pole[z + 1][x], z + 1);
                                p2 = new Vector3(x + 1, pole[z][x + 1], z);
                                p3 = new Vector3(x, pole[z - 1][x], z - 1);

                                v1 = p1 - p0;
                                v2 = p2 - p0;
                                v3 = p3 - p0;

                                n = Vector3.Cross(ref v1, ref v2) + Vector3.Cross(ref v2, ref v3) + Vector3.Cross(ref v3, ref v1);
                                n.Normalize();

                                normaly[z * size + x] = new float[3] { n.x, n.y, n.z };
                            }
                            if (x == size - 1)
                            {
                                p1 = new Vector3(x, pole[z + 1][x], z + 1);
                                p3 = new Vector3(x, pole[z - 1][x], z - 1);
                                p4 = new Vector3(x - 1, pole[z][x - 1], z);

                                v1 = p1 - p0;
                                v3 = p3 - p0;
                                v4 = p4 - p0;

                                n = Vector3.Cross(ref v1, ref v3) + Vector3.Cross(ref v3, ref v4) + Vector3.Cross(ref v4, ref v1);
                                n.Normalize();

                                normaly[z * size + x] = new float[3] { n.x, n.y, n.z };
                            }
                        }
                        else
                        {
                            normaly[z * size + x] = new float[3] { 0.0f, 0.0f, 0.0f };
                        }
                    }
                }
            }
        }

        public void render()
        {
            gl.Begin(GL.TRIANGLES);

            for (int z = 0; z < size - 1; z++)
            {
                texZ = ((float)(z) / size);
                texZplus = ((float)(z + 1) / size);
                //texZ = 0f;
                //texZplus = 1f;

                for (int x = 0; x < size - 1; x++)
                {
                    texX = ((float)(x) / size);
                    texXplus = ((float)(x + 1) / size);
                    //texX = 0f;
                    //texXplus = 1f;

                    //gl.Color3f(150 / 255f, 75 / 255f, 0f);
                    gl.Normal3fv(normaly[z * size + x]);
                    gl.TexCoord2f(texX, texZ);
                    gl.Vertex3f(2 * x, pole[z][x], 2 * z);
                    gl.Normal3fv(normaly[z * size + x + 1]);
                    gl.TexCoord2f(texXplus, texZ);
                    gl.Vertex3f(2 * (x + 1), pole[z][x + 1], 2 * z);
                    gl.Normal3fv(normaly[(z + 1) * size + x]);
                    gl.TexCoord2f(texX, texZplus);
                    gl.Vertex3f(2 * x, pole[z + 1][x], 2 * (z + 1));

                    //gl.Color3f(150 / 255f, 100 / 255f, 0f);
                    gl.Normal3fv(normaly[z * size + x + 1]);
                    gl.TexCoord2f(texXplus, texZ);
                    gl.Vertex3f(2 * (x + 1), pole[z][x + 1], 2 * z);
                    gl.Normal3fv(normaly[(z + 1) * size + x]);
                    gl.TexCoord2f(texX, texZplus);
                    gl.Vertex3f(2 * x, pole[z + 1][x], 2 * (z + 1));
                    if ((z + 1) * size + (x + 1) < normaly.Length - 1)
                    {
                        gl.Normal3fv(normaly[(z + 1) * size + (x + 1)]);
                    }
                    gl.TexCoord2f(texXplus, texZplus);
                    gl.Vertex3f(2 * (x + 1), pole[z + 1][x + 1], 2 * (z + 1));
                }
            }
            gl.End();
        }

        public void destroy()
        {
            pole = null;
            normaly = null;
        }
    }
}
