﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenGL4NET;

namespace Semestralka
{
    class Ground_zaloha
    {
        static int size;
        byte[][] pole;
        Vector3[] vrcholy;

        uint[] index = new uint[48768];

        uint vertexVBO, indexVBO;

        public Ground_zaloha(byte[][] pole)
        {
            this.pole = pole;
            size = pole.Length;
            vrcholy = new Vector3[size * size];

            int i = 0;

            for (int y = 0; y < size; y++)
            {
                for (int x = 0; x < size; x++)
                {
                    vrcholy[y * size + x] = new Vector3(2 * x, 2 * y, pole[y][x] / 10);

                    if (x != size - 1)
                    {
                        if (y != size - 1 || y != 0)
                        {
                            index[i++] = (uint)(y * size + x);
                            index[i++] = (uint)(y * size + x + 1);
                            index[i++] = (uint)((y - 1) * size + x);
                        }
                        else
                        {
                            index[i++] = (uint)(y * size + x);
                            index[i++] = (uint)(y * size + x + 1);
                            index[i++] = (uint)((y + 1) * size + x);
                        }
                    }
                }
            }





            vertexVBO = gl.GenBuffer();
            gl.BindBuffer(GL.ARRAY_BUFFER, vertexVBO);

            // 8 * 3 * velikost floatu...rikame bufferu ze dostane vectoru po 3 hodnotach o velikosti float - alokace pameti rekl bych.
            gl.BufferData(GL.ARRAY_BUFFER, vrcholy.Length * 3 * sizeof(float), vrcholy, GL.STATIC_DRAW);

            indexVBO = gl.GenBuffer();  // pozadame o vytvoreni bufferu
            gl.BindBuffer(GL.ELEMENT_ARRAY_BUFFER, indexVBO);   //svazem buffer s polem indexu

            // 8 * 3 * velikost floatu...rikame bufferu ze dostane vectoru po 3 hodnotach o velikosti float - alokace pameti rekl bych.
            gl.BufferData(GL.ELEMENT_ARRAY_BUFFER, index.Length * sizeof(uint), index, GL.STATIC_DRAW);

            // odpojeni bufferu
            gl.BindBuffer(GL.ARRAY_BUFFER, 0);
            gl.BindBuffer(GL.ELEMENT_ARRAY_BUFFER, 0);
        }

        public void render()
        {

            gl.BindBuffer(GL.ARRAY_BUFFER, vertexVBO);
            gl.EnableClientState(GL.VERTEX_ARRAY);
            gl.VertexPointer(3, GL.FLOAT, 3 * sizeof(float), (IntPtr)0);

            gl.BindBuffer(GL.ELEMENT_ARRAY_BUFFER, indexVBO);

            gl.DrawElements(GL.TRIANGLES, index.Length, GL.UNSIGNED_INT, (IntPtr)0); //kresli krychly o 24 hodnotach.
            gl.DisableClientState(GL.VERTEX_ARRAY);

            gl.BindBuffer(GL.ARRAY_BUFFER, 0);
            gl.BindBuffer(GL.ELEMENT_ARRAY_BUFFER, 0);

        }

        public void destroy()
        {
            gl.DeleteBuffer(vertexVBO);
            gl.DeleteBuffer(indexVBO);
        }
    }
}
