﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenGL4NET;

namespace Semestralka
{
    class Planet
    {
        float[][] vertexy;

        public Planet(float size)
        {
            float s2 = size / 2;
            vertexy = new float[8][]{
                new float[3]{-s2,-s2,-s2},
                new float[3]{s2,-s2,-s2},
                new float[3]{s2,-s2,s2},
                new float[3]{-s2,-s2,s2},
                new float[3]{-s2,s2,-s2},
                new float[3]{s2,s2,-s2},
                new float[3]{s2,s2,s2},
                new float[3]{-s2,s2,s2},
            };
        }

        public void render()
        {
            // gl.Color3f(1f, 1f, 0);
            gl.Begin(GL.QUADS);

            drawFace(0, 1, 2, 3);
            drawFace(0, 1, 5, 4);
            drawFace(3, 2, 6, 7);
            drawFace(4, 5, 6, 7);
            drawFace(1, 2, 6, 5);
            drawFace(0, 3, 7, 4);

            gl.End();
        }

        private void drawFace(int a, int b, int c, int d)
        {
            gl.TexCoord2f(0f, 0f);
            gl.Vertex3fv(vertexy[a]);
            gl.TexCoord2f(1f, 0f);
            gl.Vertex3fv(vertexy[b]);
            gl.TexCoord2f(1f, 1f);
            gl.Vertex3fv(vertexy[c]);
            gl.TexCoord2f(0f, 1f);
            gl.Vertex3fv(vertexy[d]);
        }

        public void destroy()
        {
            vertexy = null;
        }
    }
}
